#!/usr/bin/python3

# Copyright (C) 2025 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

from http.server import BaseHTTPRequestHandler,HTTPServer
from os import curdir, sep
import cgi
import whisper
import simplejson

PORT_NUMBER = 8003

#This class will handles any incoming request from
#the browser 
class myHandler(BaseHTTPRequestHandler):

    #Handler for the POST requests
    def do_POST(self):
        print("do_POST");
        if self.path=="/send":
            self.data_string = self.rfile.read(int(self.headers['Content-Length']))
            print("data_string: " + self.data_string.decode())
            json_data = simplejson.loads(self.data_string)
            print("json_data: " + simplejson.dumps(json_data))
            print("MODEL: " + json_data["model"])
            print("FILE: " + json_data["file"])
            result = model.transcribe(json_data["file"], language="en")
            print("Sending response")
            self.send_response(200)
            self.end_headers()
            json_response = { "response" : result["text"] } 
            json_response_text = simplejson.dumps(json_response)
            self.wfile.write(json_response_text.encode("utf-8"))
            return          


try:
    #Create a web server and define the handler to manage the
    #incoming request
    server = HTTPServer(('', PORT_NUMBER), myHandler)
    print('Started httpserver on port ' , PORT_NUMBER)

    #Load the AI model for the Whisker ASR
    model = whisper.load_model("turbo")

    #Wait forever for incoming htto requests
    server.serve_forever()

except KeyboardInterrupt:
    print('^C received, shutting down the web server')
    server.socket.close()


