// Copyright (C) 2025 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

#ifndef QASRAIMODEL_P_H
#define QASRAIMODEL_P_H

#include <QObject>
#include <QRestAccessManager>
#include "qaimodelinterface_p.h"

class QAsrAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QAsrAiModel();
    void pushData(QVariantList data, int seed) override;

private:
    QNetworkAccessManager m_manager;
    QRestAccessManager m_restApi;
};

class QAsrAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    QAsrAiModelPlugin() {}
    AiModelPrivateInterface* createInterface() { return new QAsrAiModel(); }
};

#endif // QASRAIMODEL_P_H
