// Copyright (C) 2025 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

#ifndef QDIFFUSERAIMODEL_P_H
#define QDIFFUSERAIMODEL_P_H

#include <QObject>
#include <QRestAccessManager>
#include "qaimodelinterface_p.h"

class QDiffuserAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QDiffuserAiModel();
    void pushData(QVariantList data, int seed) override;

private:
    QNetworkAccessManager m_manager;
    QRestAccessManager m_restApi;
};

class QDiffuserAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    QDiffuserAiModelPlugin() {}
    AiModelPrivateInterface* createInterface() { return new QDiffuserAiModel(); }
};

#endif // QDIFFUSERAIMODEL_P_H
