// Copyright (C) 2025 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

#ifndef QLLMAIMODEL_P_H
#define QLLMAIMODEL_P_H

#include <QObject>
#include <QRestAccessManager>
#include "qaimodelinterface_p.h"
#include <chromadb.h>

class QLlmAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QLlmAiModel();
    void pushData(QVariantList data, int seed) override;
    void setRag(QVariantList data) override;

private:
    ChromaDb m_chromadb;
    QNetworkAccessManager m_manager;
    QRestAccessManager m_restApi;
    const QByteArray m_ollama_url_base{"http://localhost:11434/api/"};
};


class QLlmAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    QLlmAiModelPlugin() {}
    AiModelPrivateInterface* createInterface() { return new QLlmAiModel(); }
};

#endif // QLLMAIMODEL_P_H
