#ifndef QTEXT2SPEEHCAIMODEL_P_H
#define QTEXT2SPEEHCAIMODEL_P_H

#include <QObject>
#include <QRestAccessManager>
#include <QAudioSink>
#include <QAudioFormat>
#include <QScopedPointer>
#include <QBuffer>
#include "qaimodelinterface_p.h"

class QPiperAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QPiperAiModel();
    void pushData(QVariantList data, int seed) override;

private:
    QNetworkAccessManager m_manager;
    QRestAccessManager m_restApi;
    QScopedPointer<QBuffer> m_audioBuffer;
    QScopedPointer<QAudioSink> m_audioSink;
    QAudioFormat m_audioFormat;
};

class QPiperTtsAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    AiModelPrivateInterface* createInterface() { return new QPiperAiModel(); }
};

#endif // QTEXT2SPEEHCAIMODEL_P_H
