// Copyright (C) 2025 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

#ifndef QTEXT2SPEEHCAIMODEL_P_H
#define QTEXT2SPEEHCAIMODEL_P_H

#include <QObject>
#include <QSharedPointer>
#include "qaimodelinterface_p.h"

class QTextToSpeech;

class QText2SpeechAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QText2SpeechAiModel();
    void pushData(QVariantList data, int seed) override;

    QSharedPointer<QTextToSpeech> m_speech;
};


class QText2SpeechAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    AiModelPrivateInterface* createInterface() { return new QText2SpeechAiModel(); }
};


#endif // QTEXT2SPEEHCAIMODEL_P_H
