// Copyright (C) 2025 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only

#ifndef QYOLOAIMODEL_H
#define QYOLOAIMODEL_H

#include <QObject>
#include <QRestAccessManager>
#include "qaimodelinterface_p.h"

class QYoloAiModel : public AiModelPrivateInterface
{
    Q_OBJECT
public:
    QYoloAiModel();
    void pushData(QVariantList data, int seed) override;

private:
    QNetworkAccessManager m_manager;
    QRestAccessManager m_restApi;
    const QByteArray m_yolo_url_base{"http://localhost:11434/api/"};
};


class QYoloAiModelPlugin : public QAiModelPluginFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QAiModelPluginFactory/1.0" FILE "plugin.json")
    Q_INTERFACES(QAiModelPluginFactory)
public:
    AiModelPrivateInterface* createInterface() { return new QYoloAiModel(); }
};

#endif // QYOLOAIMODEL_H
